#!/usr/local/bin/perl -w
# test3DOISO v0.3 (c)2004,2006 Alexander Troosh
# (I'm use ActivePerl v5.8.4 built for MSWin32-x86-multi-thread)

use Digest::MD5 qw(md5 md5_hex);
use IO::Seekable;
use Time::Local;
use Math::BigInt lib => 'GMP';
use SDBM_File;
use Fcntl;
use File::stat;

$checksectorssigantures=1;

my $n1="bc0b199086c7f26cbc9d50f404944db4789fcbfcf7ad8dbc2120898abeaaf311eea20229035608841fa41073abbd5d37500c60b53bfb46605740381b72c9db71";
my $n2="b19462b00d8d6e1ec909ab385e06fe034bfd282e9ffdc584838c15f12593dd1e3a8b5626f1b9d0ed0c384ef6c5d14512bd72ddb85b44080e0472c03d0afc4c97";
my $pp="0x1ffffffffffffffffffffffffffffffffffffffffffffffffffffff003020300c06082a864886f70d020505000410";

my $e = "10001";


sub RSA {
	$m = $_[0]->copy->bmodpow($_[1], $_[2]);

    $m = $m->as_hex();
	if( $m =~ /^$pp/)
	{
		++$signedfiles;
        $RSASIGN{$_[0]->as_hex()}=1;
	}
	return $m;
}

sub ExpandDir($);

sub ExpandDir($)
{

	my ($s)=@_;
	my $attr;
#print "\nNEWdir\n";

	++$dirs;
	do
	{
		seek(DAT, $s*2048+20 , SEEK_SET);
		do
		{
			read(DAT, $dir_entry, 72) or die "Can't read dir_entry: '$!'\n";
			($attr,$filesize,$name,$ncops, $startsector)=unpack('Nx12Nx12A32NN', $dir_entry);
           	seek(DAT, $ncops*4, SEEK_CUR);
#			printf STDERR "%-32s [%8d bytes \@%8d] %8x\r", $name, $filesize, $startsector, $attr;

            if(($attr&255)==2)
            {
            	++$files;
			    print STDERR substr("|/-\\", ($files>>2) & 3, 1), "\b" if( ($files&0x3) == 0);
            	if ($filesize > 64 && $filesize < 2e6)
            	{
                	open(FILE, "< $ISOname") or die "Can't open $ISOname file\n";
					binmode(FILE);
					for($o=64; $o<=64*1; $o+=64)
					{
						seek(FILE, $startsector*2048+$filesize-$o, SEEK_SET);
						read(FILE, $file, 64) or die "Can't read tail of file '$name'\n";
						my $c=new Math::BigInt("0x".unpack("H*",$file));

						for($i=0; $i<=1; $i++)
						{
							RSA($c, $e, $i? $n2:$n1);
						}
					}
					close(FILE);
	           	}
            }
            elsif(($attr&255)==7)
            {
				my $pos = tell(DAT);
				ExpandDir($startsector);
	           	seek(DAT, $pos , SEEK_SET);
	        }

		} while $attr < 256;
		++$s;
#print "DO:1\n";
	} while(($attr&0xFF000000) == 0x40000000);

}

sub CheckDigitalSignature {
	my $file;

	if($_[1] < 64)
	{
		print "File without sign!? len=$_[1]";
		return;
	}

	open(FILE, "< $ISOname") or die "Can't open $ISOname file\n";
	binmode(FILE);
	seek(FILE, ($_[0]+1)*0x800 , SEEK_SET);
	read(FILE, $file, $_[1]-64) or die "Can't read ISO: '$!'\n";

	my $md5=md5_hex($file);

	read(FILE, $file, 64) or die "Can't read ISO\n";
	my $c=new Math::BigInt("0x".unpack("H*",$file));
	my $n = $_[2]? $n2 : $n1;
	my $m=RSA($c, $e, $n);

	if($m eq $pp.$md5)
	{
		print "\t:-) SIGNED!\n";
	}
	else
	{
		$badsign++;
		print "\nCheck FILE offset: $_[0], len: $_[1]\nMD5=", $md5, "\n";
		print "c=0x",unpack("H*",$file), "\t ISOs offset:", tell(FILE);
		print ":-E not signed!?\n!$m\n?$pp$md5\n";
	}	

#	$m =~ s/^$pp//;
#	print " m =", $m, "\n\n";
	close FILE;
	return $m eq $pp.$md5;
}


unless(defined $ARGV[0])
{
	print "test3DOISO v0.3 (c)2004,2006 Alexander Troosh\n";
	print "This program for test 3DO ISO, please specify name(s) of ISO\n\n";
}

($e, $n1, $n2) = map { new Math::BigInt ("0x".$_) }  $e, $n1, $n2;



while($arg = $ARGV[0])
{
    shift;
 
foreach $ISOname (($arg=~/[\?\*]/)?glob($arg):$arg)
{
    $s = $badsum = $badsign = $dirs = $files = 0;
	$signedfiles = 0;
	tie %RSASIGN, "SDBM_File", "RSAs.dbm", O_RDWR|O_CREAT, 0666 or die "Can't open RSAs.dbm: $!\n";

	print "=" x 80, "\n\nTesting file: '$ISOname'\n\n";
	print STDERR " \n$ISOname";
    $badsign=0;

	open(ISO, "< $ISOname") or die "Can't open $ISOname file\n";
	binmode(ISO);

	read(ISO, $DiscInfo, 132);
	unless($DiscInfo =~ m/^\01ZZZZZ\01/)
	{
		print "Hmm... This file don't like to 3DO ISO. Skipped\n\n\n";
		next;
	}
	$ISOSizeByHeader=unpack('x80N', $DiscInfo);
	$ISOSizeReal=stat($ISOname)->size;
	print "Size of ISO: $ISOSizeReal\n  By header: ", $ISOSizeByHeader*2048,
		  " bytes ($ISOSizeByHeader sectors)\n Difference:    ", $ISOSizeReal-$ISOSizeByHeader*2048," bytes (", $ISOSizeReal/2048-$ISOSizeByHeader, " sectors)\n\n";

	# Parsing of tags
	print "Analisys rom_tags info:\n";
	seek(ISO, 2048, SEEK_SET);
	$time="undef";
	$md5 = Digest::MD5->new;
	$md5->add($DiscInfo);
	for($i=0; $i<62; $i++)
	{
		read(ISO, $rom_tag, 32) or die "Can't read ISO\n";
		$md5->add($rom_tag);

		($b1,$b2,$b3,$b4, $b5,$b6,$b7,$b8, $offset, $len, $pad)= unpack('C8N2A16', $rom_tag);
		next unless(defined $b1);
		if(0){
		$tag1 = sprintf "ROM tag: $b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8";
		$tag2 = sprintf "%15s, %10s, '%s'", $offset, $len, $pad ;
		printf "%-28s %-20s", $tag1, $tag2;
		}
		last if($b1==0);

		if($b1!=0x0F)
		{
			print "\n!!! Unknow tag: $b1,$b2,$b3,$b4, $b5,$b6,$b7,$b8, $offset, $len, $pad\n";
			next;
		}

		unless( grep { $b2 == $_ } (2, 5, 7, 0xC, 0xD, 0x10, 0x14) )
		{
			print "\tUnknow tag=$b2!!!\n";
			print "!!! Unknow tag: $b1,$b2,$b3,$b4, $b5,$b6,$b7,$b8, $offset, $len, $pad\n";
			next;
	   	}

		if($b2==2)
		{
			print "\tFile: \"launchme\" (from $offset sector, len=$len sectors)\n";
		}
		elsif($b2==5)
		{
		    print "\tFile: \"signatures\" (from $offset sector, len=$len bytes";
			open(SIG, "< $ISOname") or die "\nCan't open signatures files\n";
			binmode(SIG);
   			# Len... One version OS set real len of file, other set to end of non zero data only 
   			# 335872 with sing, 335808 without, /= 20988 md5 sum *16*2048=687734784 max 3DO ISO size
			seek(SIG, ($offset+1)*2048+$len, SEEK_SET);
			my $rom_tag_len=$len;
			while ($len < 335872)
			{
		    	read(SIG, $md5exp, 16) or die "\nCan't read signatures files\n";
		    	last if($md5exp eq "U"x16);
				$len += 16;
			} 
			print ", real len=$len bytes)" if($rom_tag_len !=$len);
			print ")" if($rom_tag_len ==$len);

			$n=($len-64)/16;

			seek(SIG, ($offset+1)*2048, SEEK_SET);
		}
		elsif($b2==0x7)
		{
			print "\tFile: \"os_code\" (from $offset sector, len=$len bytes)";

			open(DAT, "< $ISOname") or die "Can't open $ISOname file\n";
			binmode(DAT);

			seek(DAT, ($offset+1)*0x800 , SEEK_SET);
			my $os_code;
			read(DAT, $os_code, $len-64) or die "Can't read file os_code: '$!'\n";
			close(DAT);

            $os_code_md5=md5_hex($os_code);
		}
		elsif($b2==0xc)
		{
			print "\tThis is Date of Release tag\n";
#			$time=$offset;
#??			$time=gmtime(timegm(0,0,0,1,1,1904) + $offset);
			$time=gmtime(timegm(0,0,0,1,1,1976) + $offset - (timegm(0,0,0,1,1,1986)-timegm(0,0,0,1,1,1974))*6);
		}
		elsif($b2==0xd)
		{
		    print "\tFile: \"boot_code\" (from $offset sector, len=$len)";
			open(DAT, "< $ISOname") or die "Can't open $ISOname file\n";
			binmode(DAT);

			seek(DAT, ($offset+1)*0x800 , SEEK_SET);
			read(DAT, $boot_code, $len-128) or die "Can't read file boot_code: '$!'\n";
            $boot_code_md5=md5_hex($boot_code);

			seek(DAT, ($offset+1)*0x800 , SEEK_SET);
			read(DAT, $boot_code, $len) or die "Can't read file boot_code: '$!'\n";
			close(DAT);
		}
		elsif($b2==0x10)
		{
			print "\tFile: \"misc_code\" (from $offset sector, len=$len bytes)";
			open(DAT, "< $ISOname") or die "Can't open $ISOname file\n";
			binmode(DAT);

			seek(DAT, ($offset+1)*0x800 , SEEK_SET);
			my $misc_code;
			read(DAT, $misc_code, $len-64) or die "Can't read file boot_code: '$!'\n";
			close(DAT);

            $misc_code_md5=md5_hex($misc_code);

		}
		elsif($b2==0x14)
		{
			print "\tFile: \"BannerScreen\" (from $offset sector, len=$len bytes)";
		}

		if($b2==5 || ($b2==0x14)) #signatures
		{
			CheckDigitalSignature($offset, $len, 0);
		}
		elsif( ($b2==7) || ($b2==0xd) || ($b2==0x10))
		{
			CheckDigitalSignature($offset, $len, 1);
		}

	}
	read(ISO, $rom_tag_sign, 64) or die "Can't read rom_tag signature\n";
	
	$md5->add($boot_code); #    boot_code   
	$md5=$md5->hexdigest;
	my $c=new Math::BigInt("0x".unpack("H*",$rom_tag_sign));
	my $m=RSA($c, $e, $n1);

	if($m eq $pp.$md5)
	{
		print "\n:-) DiscInfo, rom_tag & boot_code is SIGNED!\n\n";
	}
	else
	{
		$badsign++;
		print "\n:-E rom_tag not signed?\n!$m\n?$pp$md5\n";
		print "\t ISOs offset:", tell(ISO)-64, "\n";
		print "c=", $c->as_hex(), "\ne=", $e->as_hex(), "\n";
		print "m=", $m, "\n\n\n";
	}	

	seek(ISO, 0, SEEK_SET);
	print "Date of disk release is: \"$time\"\n";

if($checksectorssigantures)
{
	$|=1;

	print "Please wait...\n\n";


	$s=$i=$badsum=0;
	print STDERR "  MD5 checking...";
	while($n-- > 4)
	{

	    read(SIG, $md5exp, 16);
	    read(ISO, $sector, 2048*16);

	    if($md5exp eq "\0"x16)
	    {
	    	$i++;
	    	next;
	    }

	    print STDERR substr("|/-\\", ($s>>6) & 3, 1), "\b" if( ($s&0x3F) == 0);
#	    print $s, "\r";
	    $s++;
	    $md5sum=md5($sector);
		next if $md5exp eq md5($sector);

		$badsum++;	
		print	"BAD group of sectors: ", $s-1, "\n\texpect:\t\t",
				unpack("H*",$md5exp),	"\n\tcalculated:\t",
				unpack("H*",$md5sum), "\n\n";
	}

	if( ($badsum > 0) || ($badsign > 0) )
	{
		print ":-( This is BAD 3DO's ISO ($badsign bad sign, $badsum of $s is bad MD5 sum, skipped: $i)\n\n",
	}
    else
    {
		print ":-) This is GOOD 3DO's ISO\n\tpassed: $s MD5 sums\n\tskipped: $i\n";
	}
    $md5skiped = $i;
}
else
{
	print "*** Test of CD image skiped\n\n";
}

#    
	print STDERR "  files scan...";
	$dirsector=unpack('x100N', $DiscInfo);
	open(DAT, "< $ISOname") or die "Can't open $ISOname file\n";
	binmode(DAT);
    ExpandDir( $dirsector);
    close(DAT);
    print "$dirs dirs/ $files files ($signedfiles signed)\n";

	{ # Save info to DB
		print "\nAppend to file: \"ISOs.info\" info about this ISO\n\n";
		open DB, ">> ISOs.info";
		print DB "$md5 \"$time\" $ISOname\n";
		close DB;

		tie %ISOsINFO, "SDBM_File", "ISOs.dbm", O_RDWR|O_CREAT, 0666
			or die "Can't open ISOs.dbm: $!\n";
		$ISOsINFO{$md5}=join("\t", $boot_code_md5, $os_code_md5, $misc_code_md5, $badsign, $s, $md5skiped, $badsum, "\"$time\"", $ISOname);
		untie %ISOsINFO;
	}
	untie %RSASIGN;

	close SIG;
	close ISO;
}
}

